Subject: RE: bug#9134: don't force mystery on user trying to find out what is completing after the word "ssh" in *shell*

From: Drew Adams <[email-masked]>
Date: Mon, 14 Oct 2019 04:46:44 +0000 (UTC)

> >> When we hit TAB in *shell* after the word "ssh",
> >>
> >> * there are no messages about where in the world it is getting its
> >>   completions. Unlike dabbrev-expand.
> >
> > That is pretty mysterious behaviour; yes.  Would flashing a message
> > saying "Looking for host names in ~/.ssh/known_hosts and
> ~/.ssh/config"
> > be helpful?
> 
> I think it would be nicer if the *Completions* buffer text explained
> it.  i.e. additional information added to this:
> 
> "Click on a completion to select it.
> In this buffer, type RET to select the completion near point.
> 
> Possible completions are:"
> 
> That's mostly from `completion-setup-function'.  Perhaps that could be
> made to incorporate text from a new var, which could then be bound
> dynamically in cases where extra context was desirable?

Doesn't the command performing the completion know
this information?  Why isn't it sufficient for `C-h f'
for that command to provide the info?  I'd think that
if it's not obvious the command's doc should let you
know what things you're completing against.

A priori, I don't think the info should be shown via
a transitory message or by putting an explanation in
buffer *Completions*.

A priori, I think the proper place to explain/describe
the completion behavior (what it does, including what
the possible completions are) is the command's doc.